// Copyright 2020 the Pinniped contributors. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/suzerain-io/pinniped/generated/1.18/apis/pinniped/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeCredentialRequests implements CredentialRequestInterface
type FakeCredentialRequests struct {
	Fake *FakePinnipedV1alpha1
}

var credentialrequestsResource = schema.GroupVersionResource{Group: "pinniped.dev", Version: "v1alpha1", Resource: "credentialrequests"}

var credentialrequestsKind = schema.GroupVersionKind{Group: "pinniped.dev", Version: "v1alpha1", Kind: "CredentialRequest"}

// Get takes name of the credentialRequest, and returns the corresponding credentialRequest object, and an error if there is any.
func (c *FakeCredentialRequests) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.CredentialRequest, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(credentialrequestsResource, name), &v1alpha1.CredentialRequest{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.CredentialRequest), err
}

// List takes label and field selectors, and returns the list of CredentialRequests that match those selectors.
func (c *FakeCredentialRequests) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.CredentialRequestList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(credentialrequestsResource, credentialrequestsKind, opts), &v1alpha1.CredentialRequestList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.CredentialRequestList{ListMeta: obj.(*v1alpha1.CredentialRequestList).ListMeta}
	for _, item := range obj.(*v1alpha1.CredentialRequestList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested credentialRequests.
func (c *FakeCredentialRequests) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(credentialrequestsResource, opts))
}

// Create takes the representation of a credentialRequest and creates it.  Returns the server's representation of the credentialRequest, and an error, if there is any.
func (c *FakeCredentialRequests) Create(ctx context.Context, credentialRequest *v1alpha1.CredentialRequest, opts v1.CreateOptions) (result *v1alpha1.CredentialRequest, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(credentialrequestsResource, credentialRequest), &v1alpha1.CredentialRequest{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.CredentialRequest), err
}

// Update takes the representation of a credentialRequest and updates it. Returns the server's representation of the credentialRequest, and an error, if there is any.
func (c *FakeCredentialRequests) Update(ctx context.Context, credentialRequest *v1alpha1.CredentialRequest, opts v1.UpdateOptions) (result *v1alpha1.CredentialRequest, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(credentialrequestsResource, credentialRequest), &v1alpha1.CredentialRequest{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.CredentialRequest), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeCredentialRequests) UpdateStatus(ctx context.Context, credentialRequest *v1alpha1.CredentialRequest, opts v1.UpdateOptions) (*v1alpha1.CredentialRequest, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(credentialrequestsResource, "status", credentialRequest), &v1alpha1.CredentialRequest{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.CredentialRequest), err
}

// Delete takes name of the credentialRequest and deletes it. Returns an error if one occurs.
func (c *FakeCredentialRequests) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(credentialrequestsResource, name), &v1alpha1.CredentialRequest{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeCredentialRequests) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(credentialrequestsResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.CredentialRequestList{})
	return err
}

// Patch applies the patch and returns the patched credentialRequest.
func (c *FakeCredentialRequests) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.CredentialRequest, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(credentialrequestsResource, name, pt, data, subresources...), &v1alpha1.CredentialRequest{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.CredentialRequest), err
}
